(function() {
"use strict";

this.name           = "miningMethods";
this.author         = "Docwild";
this.copyright      = "GNU GENERAL PUBLIC LICENSE";
this.licence        = "GNU GENERAL PUBLIC LICENSE V2";
this.description    = "Mining and yoursing, too";
this.version        = "1.0 beta 1";

this.playerClaimedMines     = [];
this.playerClaimedPositions = []; // for the vector coordinates of said mines
this.playerClaimedSysName   = []; // for the name of the system where the mine is
this.playerClaimedName      = []; // for the displayName

//Production variables
this.playerClaimedUnitsPerDay        = []; // How many units the mine is producing
this.playerClaimedTimeSinceOwned     = []; // the day the player took over
this.playerClaimedTimeSinceVisited   = []; // time since restocking
//this.playerClaimedDaysOfProduction = []; // How many days has this mine been producing product

//booleans
this.playerClaimedDefence   = [];
this.playerClaimedNarcotics = [];
this.playerClaimedLiquor    = [];
this.playerClaimedProducing = [];
this.playerClaimedMorality  = [];

this.illicitChoice            = new Object();
this.illicitChoice.title      = "Extras?";
this.illicitChoice.message    = "\t\tIt is possible to improve the productivity of this mine:";
this.illicitChoice.message   += "\n\n\n\n\n\n\n\n\n\n\tPlease select an option, commander:";
this.illicitChoice.choicesKey = "mine_illicitChoice";

this.mineMenu  = new Object();
this.visitMenu = new Object();

this.timeAdjust = false;

this.AIRefusal = [
    "this mine requires 5t slaves and 20t of food to transfer claim. Get me my slaves or get out.", 
    "you have insufficient resources, are you wasting my time? Bring 5t slaves and 20t of food.", 
    "what do you want? I was sleeping. hmmph.. next time you better have 5t slaves and 20t of food!",
    "5t slaves and 20t of food are needed to begin mining."
];

let L = false; // Debug logging


this.asteroidMine = function(mineStatus, minePos, role) {
    if (L) log("miningMethods", ">Constructor: mineStatus = " + mineStatus + " minePos = " + minePos + " role = " + role);

    let thisRef     = this; // this is required for the timer callback
    this.baseName   = "SlaveMine";
    this.mineStatus = mineStatus;
    this.sysName    = system.name;
    this.producing  = false;
    this.narcBonus  = false;
    this.liqBonus   = false;
    this.defence    = false;
    this.role       = role;
    this.mineEntity = [];
    this.morality   = null;

    if (minePos) {
        if (L) ("miningMethods", "Known position");
        this.minePos = Vector3D(minePos);
        this.lightSpeedDelay = parseFloat( player.ship.position.distanceTo(this.minePos) / 18600 );
        this.placeKnownAsteroid(this.role)
    }
    else {
        this.placeUnknownAsteroid(this.role);
    }

    this.distance = parseInt(this.lightSpeedDelay * 186000);//in miles
    this.miningPoints = 0; //production factor
    this.changeType(this.baseName + this.mineStatus);

    if ( this.mineStatus === "-OWNED" ) {
        this.ownedStats();
    }
    else {
        //ship member props
        this.unitsPerDay = 0;
        this.timeSinceOwned = 0;
        this.timeSinceVisited = 0;
        //this.daysOfProduction = 0;
    }

    if (L) log("miningMethods", " this.mineEntity = " + this.mineEntity);

    //inline function. DAMN YOU JS. I hate you. DIE
    this.firstActTimer = new Timer(worldScripts.miningMethods, function(){ thisRef.firstAct(); } , thisRef.lightSpeedDelay, -1);
    if (L) log("miningMethods", "this.firstActTimer = " + this.firstActTimer + " thisRef.lightSpeedDelay = " + thisRef.lightSpeedDelay);
    this.firstActTimer.stop();//wait for launch/jump
};

this.asteroidMine.prototype.lostClaim = function() {
    this.mineStatus = "-UNCLAIMED";

    this.producing = false;
    this.narcBonus = 0;
    this.liqBonus = 0;
    this.miningPoints = 0; //production factor
    this.changeType(this.baseName + this.mineStatus);
    this.unitsPerDay = 0;
    this.timeSinceOwned = 0;
    this.timeSinceVisited = 0;
    //this.daysOfProduction = 0;
}

//remove by position
this.asteroidMine.prototype.removeFromArray = function(position) {
    var indexOfAsteroid = null;
    for ( var i = 0;i < worldScripts.miningScript.systemAsteroidObjects.length;i++ )
    {
            if(this.minePos.distanceTo(position) < 500)
            {
                indexOfAsteroid = i;
                break;
            }
    }
    if ( indexOfAsteroid != null )
    {
        let temp = worldScripts.miningScript.systemAsteroidObjects[indexOfAsteroid];
        worldScripts.miningScript.systemAsteroidObjects = worldScripts.miningMethods.removeFromArray(worldScripts.miningScript.systemAsteroidObjects, indexOfAsteroid);
        temp = null;
    }
    else {
        if (L) log("miningMethods", "Could not find object to remove");
    }
}
//for those who don't know, protoype functions are class methods (or struct member functions)... 
//blame microsoft for the naming, and netscape.. and you may as well kick Bjarne Stroubleugh as well, pretentious git

this.asteroidMine.prototype.firstAct = function() {
    let thisRef = this;
    if (L) log(worldScripts.miningMethods, ">firstAct");
    if(this.sysName == system.name)
    {
        switch(this.mineStatus)
        {
            case "-OWNED":        
                if (L) log(worldScripts.miningMethods, "owned asteroid...");
                if(worldScripts.miningMethods.timeAdjust)
                    timeAccelerationFactor = 1;
                
                //beacon pre-exists for owned mines, this informs player that this system contains one of their asteroids
                player.consoleMessage("Owned Mine: " + this.baseName + this.mineStatus + " " + this.minePos + "\nUpdate delayed by " + parseInt(this.lightSpeedDelay) + " seconds"+ " DISTANCE = " + this.distance + " miles." , 5);

                break;
            case "-CLAIMED":        
                if (L) log(worldScripts.miningMethods, "claimed asteroid...");
                var shipSecondDelay = parseFloat(this.minePos.distanceTo(player.ship.position)/18600);// light :/
                this.revealBeaconTimer = new Timer(worldScripts.miningMethods, function(){worldScripts.miningMethods.revealBeacon(thisRef.minePos, thisRef);}, shipSecondDelay, -1);//this timer will be the new lightspeed delay.
                break;
            case "-UNCLAIMED":
                if (L) log(worldScripts.miningMethods, "unclaimed asteroid...");
                worldScripts.miningMethods.updateBeacon(this.minePos, "Unclaimed beacon received. Distance: " + this.distance+" miles.", "-UNCLAIMED");
                break;
        }
    }
}

this.asteroidMine.prototype.ownedStats = function() {
    if (L) log("miningMethods", ">ownedStats");
    for ( var i = 0; i < worldScripts.miningMethods.playerClaimedMines.length; i++ ) {
        var position = Vector3D( worldScripts.miningMethods.playerClaimedPositions[i] );
        if ( position.distanceTo(this.minePos) < 500 && system.name == worldScripts.miningMethods.playerClaimedSysName[i] ) {
            if (L) log("miningMethods", "worldScripts.miningMethods.playerClaimedPositions[i]" + worldScripts.miningMethods.playerClaimedPositions[i]);
            this.unitsPerDay = worldScripts.miningMethods.playerClaimedUnitsPerDay[i];
            this.timeSinceOwned = worldScripts.miningMethods.playerClaimedTimeSinceOwned[i];
            this.timeSinceVisited = worldScripts.miningMethods.playerClaimedTimeSinceVisited[i];
            //this.daysOfProduction = worldScripts.miningMethods.playerClaimedDaysOfProduction[i];
            this.producing = worldScripts.miningMethods.playerClaimedProducing[i];
        }
    }
}

this.asteroidMine.prototype.takeOverMine = function() {
    let stocked = false;
    let missObj = {
        title:      "Take Over Mine",
        message:    "There are always options, commander:",
        choicesKey: "mine_choice"
    };

    callback.static = 0;

    let alreadyOwned = false;
    for ( let i = 0; i < worldScripts.miningMethods.playerClaimedMines.length; i++ ) {
        if(system.name == worldScripts.miningMethods.playerClaimedSysName[i] && this.minePos.distanceTo(worldScripts.miningMethods.playerClaimedPositions[i]) < 1000)
        {
            alreadyOwned = true;
            break;
        }
    }
    mission.runScreen(missObj, callback, this); //pass the "this" parcel
    function callback (choice)
    {
        callback.static ++;
        if (L) log("worldScripts.miningMethods", "choice = " + choice );
        
        if(choice === "1_SLAVES")
        {
            
            if (L) log("worldScripts.miningMethods", "SLAVES choice = " + choice + " this = " + this);
            if(worldScripts.miningMethods.checkManifest("food") && worldScripts.miningMethods.checkManifest("slaves"))
            {
                player.ship.manifest.food -= 20;
                player.ship.manifest.slaves -= 5;
                player.commsMessage("You have taken over the mine, 20t of food and 5t of slaves have been transferred, mining is underway. Have a nice day.");
                this.unitsPerDay += 10;
                if ( ! alreadyOwned )
                {
                    this.morality = "slave";
                    tookMine(this);
                }
                else
                    mission.runScreen(worldScripts.miningMethods.illicitChoice, worldScripts.miningMethods.illCall, thisRef); //pass the "this" parcel
            }
            else {
                player.commsMessage("You don't have enough!");
                if ( callback.static < 3 ) {
                    mission.runScreen( missObj, callback, this );
                }
                else {
                    system.addShips("pirate", 5, this.minePos);
                    player.commsMessage("Stop wasting my time!")
                    launch(this);
                }
            }
            
        }
        else if(choice === "2_AUTOMATED")
        {
            if (L) log("worldScripts.miningMethods", "AUTO choice = " + choice);
            if(worldScripts.miningMethods.checkManifest("computers") && worldScripts.miningMethods.checkManifest("machinery"))
            {
                player.ship.manifest.machinery -= 20;
                player.ship.manifest.computers -= 5;
                player.commsMessage("You have taken over the mine, 20t of machinery and 5t of computers have been transferred, mining is underway. Have a nice day.");
                this.unitsPerDay += 5;
                if(!alreadyOwned)
                {
                    this.morality = "auto";
                    tookMine(this);
                }
                else
                    mission.runScreen(worldScripts.miningMethods.illicitChoice, worldScripts.miningMethods.illCall, thisRef); //pass the "this" parcel
            }
            else
            {
                player.commsMessage("You don't have enough!");
                if(callback.static < 3)
                    mission.runScreen(missObj, callback, this);
                else
                {
                    system.addShips("pirate", 5, this.minePos);
                    player.commsMessage("Stop wasting my time!")
                    launch(this);
                }
                
            }
        }
        
        else if(choice === "3_NOT_NOW")
        {
            if (L) log("worldScripts.miningMethods", "NOTNOW choice = " + choice);
            
            player.commsMessage("Maybe next time");
            
            launch(this);
        }
        else
            if (L) log("worldScripts.miningMethods", "ELSEERROR  choice = " + choice);
        
        function launch(thisRef)//this parcel
        {
            if (L) log("miningMethods", " launch()");
            if(player.ship.docked)
                player.ship.launch();
           // var astObj = worldScripts.miningMethods.getObject(player.ship.position)
           // if(astObj != null)
           // {
                if(thisRef.mineStatus == "-CLAIMED")
                {
                    if (L) log("worldScripts.miningMethods", "NOTNOWCLAIMED launch()ed");
                    var delay = new Timer(thisRef, function()//this parcel
                    {
                        Sound.stopMusic(worldScripts.miningScript.peaceMusic);
                        Sound.playMusic(worldScripts.miningScript.hostileMusic, true);
                        
                        var ships = system.addGroup("pirate", 5, this.minePos);
                        player.commsMessage("What the frak are you doing here?");
                        ships.target = player.ship;
                    }, 5, -1);
                }
          //  }
        }
        function tookMine(thisRef)//this parcel
        {
            if (L) log("worldScripts.miningMethods", "Taking over mine");
            Sound.stopMusic(worldScripts.miningScript.hostileMusic);
            Sound.playMusic(worldScripts.miningScript.peaceMusic, true);
            thisRef.producing = true;
            thisRef.timeSinceOwned = clock.days;
            thisRef.timeSinceVisited = clock.days;
            
            var claimedNumber = worldScripts.miningMethods.playerClaimedMines.length;
            
            thisRef.changeType("SlaveMine-OWNED");
            thisRef.mineStatus = "-OWNED";
            
            //worldScripts.miningScript.systemAsteroids[iterator] = thisRef.minePos + system.name + " " + thisRef.baseName + thisRef.mineStatus;
            missionVariables["miningPlayerClaimedID" + claimedNumber] = thisRef.timeSinceOwned +"*"+thisRef.timeSinceVisited+"^"
                    +thisRef.producing+"£"+thisRef.morality+"$"+thisRef.unitsPerDay+"{"+ thisRef.defence + "}"+ thisRef.narcBonus+"#"
                    +thisRef.liqBonus+ thisRef.minePos + system.name + " " + thisRef.baseName + thisRef.mineStatus;
            
            
            //pushy pushy
            worldScripts.miningMethods.playerClaimedMines.push(missionVariables["miningPlayerClaimedID" + claimedNumber]);//add to array
            worldScripts.miningMethods.playerClaimedPositions.push(worldScripts.miningMethods.getPositionVector(missionVariables["miningPlayerClaimedID" + claimedNumber]));
            worldScripts.miningMethods.playerClaimedSysName.push(worldScripts.miningMethods.getSystemName(missionVariables["miningPlayerClaimedID" + claimedNumber]));
            worldScripts.miningMethods.playerClaimedName.push(worldScripts.miningMethods.getDisplayName(missionVariables["miningPlayerClaimedID" + claimedNumber]));
            worldScripts.miningMethods.playerClaimedUnitsPerDay.push(worldScripts.miningMethods.getUnitsPerDay(claimedNumber));
            worldScripts.miningMethods.playerClaimedTimeSinceOwned.push(worldScripts.miningMethods.getTimeSinceOwned(claimedNumber));
            worldScripts.miningMethods.playerClaimedTimeSinceVisited.push(worldScripts.miningMethods.getTimeSinceVisited(claimedNumber));
            worldScripts.miningMethods.playerClaimedProducing.push(worldScripts.miningMethods.getProducing(claimedNumber));
            //worldScripts.miningMethods.playerClaimedDaysOfProduction.push(worldScripts.miningMethods.getDaysOfProduction(claimedNumber));
            worldScripts.miningMethods.playerClaimedDefence.push(worldScripts.miningMethods.getDefence(claimedNumber));
            worldScripts.miningMethods.playerClaimedNarcotics.push(worldScripts.miningMethods.getNarcotics(claimedNumber));
            worldScripts.miningMethods.playerClaimedLiquor.push(worldScripts.miningMethods.getLiquor(claimedNumber));
            worldScripts.miningMethods.playerClaimedMorality.push(worldScripts.miningMethods.getMorality(claimedNumber));
            
            worldScripts.miningScript.miningClaimedNumber++;
            
            mission.runScreen(worldScripts.miningMethods.illicitChoice, worldScripts.miningMethods.illCall, thisRef); //pass the "this" parcel

            
            if (L) log("worldScripts.miningMethods", "Took over asteroid: " + thisRef.baseName + thisRef.mineStatus + " @ " + thisRef.minePos);
        }
    }
}

this.asteroidMine.prototype.vistingMine = function() {
    if (L) log("worldScripts.miningMethods", "VISITMINE");
    var thisRef = this;
    worldScripts.miningMethods.visitMenu.title = "Mine Admin";
    worldScripts.miningMethods.visitMenu.message = "Select Task:";
    worldScripts.miningMethods.visitMenu.choicesKey = "mine_visit";
    Sound.playMusic(worldScripts.miningScript.peaceMusic, true);
    mission.runScreen(worldScripts.miningMethods.visitMenu, visitMenuFunc, thisRef);
    function visitMenuFunc (choice)
    {
        
        worldScripts.miningMethods.visitMenu.message = "Select Task:";
        var daysVisit = clock.days - thisRef.timeSinceVisited;
        var daysOwned = clock.days - thisRef.timeSinceOwned;
        if (L) log("worldScripts.miningMethods", "VISITMENUFUNC: DaysVisit = " + daysVisit);
        if(choice == "1_RESTOCK")
        {
            if (L) log("worldScripts.miningMethods", "RESTOCK");
            if(!thisRef.producing)
            {
                if (L) log("worldScripts.miningMethods", "Not Producing");
                if(thisRef.morality == "slave")
                {
                    if (L) log("worldScripts.miningMethods", "Restock non producing slaves");
                    var slave = worldScripts.miningMethods.checkManifest("slaves");
                    var food = worldScripts.miningMethods.checkManifest("food");
                    if(!slave || !food)
                    {
                        if (L) log("worldScripts.miningMethods", "Lack slave+food");
                        worldScripts.miningMethods.visitMenu.message = "You have a claim here but you do not have enough resources to restock this mine.";
                        worldScripts.miningMethods.visitMenu.message += "\nPlease restock, no resources will be available until you do";
                        worldScripts.miningMethods.visitMenu.message += "\n\nSelect Task:";
                        mission.runScreen(worldScripts.miningMethods.visitMenu, visitMenuFunc, this);
                    }
                    else if (slave && food)
                    {
                        if (L) log("worldScripts.miningMethods", "Not producing, restocking slaves+food");
                        player.ship.manifest.food -= 20;
                        player.ship.manifest.slaves -= 5;
                        thisRef.unitsPerDay += 10;
                        player.commsMessage("You have restocked the mine, production restarted.");
                        thisRef.producing = true;
                        thisRef.timeSinceVisited = clock.days;
                        mission.runScreen(worldScripts.miningMethods.illicitChoice, worldScripts.miningMethods.illCall, this); //pass the "this" parcel
                    }
                }
                else if (thisRef.morality == "auto")
                {
                    if(L) log("worldScripts.miningMethods", "Restock non producing auto");
                    var machine = worldScripts.miningMethods.checkManifest("machinery");
                    var computers = worldScripts.miningMethods.checkManifest("computers");
                    if(!machine || !computers)
                    {
                        if(L) log("worldScripts.miningMethods", "Lack computers + machine");
                        worldScripts.miningMethods.visitMenu.message = "You have a claim here but you do not have enough resources to restock this mine.";
                        worldScripts.miningMethods.visitMenu.message += "\nPlease restock, no resources will be available until you do";
                        worldScripts.miningMethods.visitMenu.message += "\n\nSelect Task:";
                        mission.runScreen(worldScripts.miningMethods.visitMenu, visitMenuFunc, this);
                    }
                    else if (machine && computers)
                    {
                        if(L) log("worldScripts.miningMethods", "Restock non producing machines+comps");
                        player.ship.manifest.machinery -= 20;
                        player.ship.manifest.computers -= 5;
                        thisRef.unitsPerDay += 5;
                        player.commsMessage("You have restocked the mine, production restarted.");
                        thisRef.producing = true;
                        thisRef.timeSinceVisited = clock.days;
                        mission.runScreen(worldScripts.miningMethods.illicitChoice, worldScripts.miningMethods.illCall, this); //pass the "this" parcel
                    }
                }
            }
            else
            {//already producing, player wants to restock illicits
                if(L) log("worldScripts.miningMethods", "Is Producing, calling illicit goods");
                mission.runScreen(worldScripts.miningMethods.illicitChoice, worldScripts.miningMethods.illCall, this);
            }
        }
        else if (choice == "2_CHANGE_TYPE")
        {
            if(L) log("worldScripts.miningMethods", "CHANGETYPE");
            if(daysVisit > 1)
            {
                if(player.ship.cargoSpaceAvailable >= 1  && thisRef.producing)
                {//unload goods
                    if(L) log("worldScripts.miningMethods", "got space, daysvisit >1, is producing");
                    var daysOfProduction = thisRef.timeSinceVisited - clock.days;
                    if(thisRef.morality == "slave")
                        thisRef.morality = "auto";
                    else if (thisRef.morality == "auto")
                        thisRef.morality = "slave";
                    thisRef.unitsPerDay = 0;
                    thisRef.producing = false;
                    player.commsMessage((thisRef.unitsPerDay * daysOfProduction).toString() + " kgs of Gold have been transferred");
                    player.ship.manifest.gold += thisRef.unitsPerDay   * daysOfProduction;
                    //this.daysOfProduction = 0;
                    thisRef.timeSinceVisited = clock.days;
                   mission.runScreen(worldScripts.miningMethods.visitMenu, visitMenuFunc, this);

                }
                else if (player.ship.cargoSpaceAvailable == 0 && thisRef.producing)
                {
                    if(L) log("worldScripts.miningMethods", "No space, daysvisit>1, is producing");
                    worldScripts.miningMethods.visitMenu.message = "Unable to change type as you have no cargo space, I'll hold on to your goods until you redock with more space.";
                    worldScripts.miningMethods.visitMenu.message += "\n\nSelect Task:";
                    mission.runScreen(worldScripts.miningMethods.visitMenu, visitMenuFunc, this);
                    //worldScripts.miningMethods.illicitExtras(ownedEntities[i]);
                }

                else
                {
                    if(L) log("worldScripts.miningMethods", "Else");
                   mission.runScreen(worldScripts.miningMethods.visitMenu, visitMenuFunc, this);

                }
                //mission.runScreen(worldScripts.miningMethods.visitMenu, visitMenuFunc, this);
                
            }
            else if(daysVisit < 1)
            {
                if(L) log("worldScripts.miningMethods", "Less than a day");
                if(thisRef.morality == "slave")
                    thisRef.morality = "auto";
                else if (thisRef.morality == "auto")
                    thisRef.morality = "slave";
                if(L) log("worldScripts.miningMethods", "Less than a day thisRef.morality = "+thisRef.morality );
                thisRef.unitsPerDay = 0;
                thisRef.producing = false;
                thisRef.timeSinceVisited = clock.days;
                if(thisRef.morality = "auto")
                {
                    worldScripts.miningMethods.visitMenu.message = "Changed to " + thisRef.morality + " type mine";
                    worldScripts.miningMethods.visitMenu.message += "\nPlease select Restock. You will require 5t of Computers and 20t of Machinery\n\nSelect Task:";
                }
                else if (thisRef.morality = "slave")
                {
                    worldScripts.miningMethods.visitMenu.message = "Changed to " + thisRef.morality + " type mine";
                    worldScripts.miningMethods.visitMenu.message += "\nPlease select Restock. You will require 5t of Slaves and 20t of Food\n\nSelect Task:";
                }
               mission.runScreen(worldScripts.miningMethods.visitMenu, visitMenuFunc, this);
                
            }
        }
        else if (choice == "3_GET_GOODS")
        {
            if(L) log("worldScripts.miningMethods", "GETGOODS");
            if(daysVisit > 1  && thisRef.producing)
            {
                if(L) log("worldScripts.miningMethods", "Daysvisit>1, is producing");
                
                if(player.ship.cargoSpaceAvailable >= 1 )
                {

                    var daysOfProduction =  clock.days -thisRef.timeSinceVisited;
                    if(L) log("worldScripts.miningMethods", "Enough space: unitsPerDay = " + thisRef.unitsPerDay + "thisRef.timeSinceVisited = " + thisRef.timeSinceVisited );
                    player.commsMessage((thisRef.unitsPerDay * daysOfProduction).toString() + " kgs of Gold have been transferred");
                    player.ship.manifest.gold += (thisRef.unitsPerDay * daysOfProduction);
                    //thisRef.daysOfProduction = 0;
                    thisRef.timeSinceVisited = clock.days;
                    mission.runScreen(worldScripts.miningMethods.visitMenu, visitMenuFunc, this);
                }
                else
                {
                    if(L) log("worldScripts.miningMethods", "No space");
                    worldScripts.miningMethods.visitMenu.message = "You have no cargo space, I'll hold on to your goods until you redock with more space.";
                    worldScripts.miningMethods.visitMenu.message += "\n\nSelect Task:";
                    mission.runScreen(worldScripts.miningMethods.visitMenu, visitMenuFunc, this);
                    //worldScripts.miningMethods.illicitExtras(ownedEntities[i]);
                }
               // mission.runScreen(worldScripts.miningMethods.illicitChoice, worldScripts.miningMethods.illCall, thisRef); //pass the "this" parcel
            }
            else if (daysVisit < 1)
            {
                if(L) log("worldScripts.miningMethods", "Daysvisit < 1");
                worldScripts.miningMethods.visitMenu.message = "This mine has been working for less than one day";
                worldScripts.miningMethods.visitMenu.message += "\n\nSelect Task:";
                mission.runScreen(worldScripts.miningMethods.visitMenu, visitMenuFunc, this);
            }
            // mission.runScreen(worldScripts.miningMethods.illicitChoice, worldScripts.miningMethods.illCall, this);
        }
        else if (choice == "4_LAUNCH")
        {
            if(player.ship.docked)
                player.ship.launch();
        }
    }
}

this.asteroidMine.prototype.updateClaimed = function() {

    for(var i = 0; i < worldScripts.miningMethods.playerClaimedMines.length; i ++)
    {
        if(this.minePos.distanceTo(worldScripts.miningMethods.playerClaimedPositions[i]) < 1000 && worldScripts.miningMethods.playerClaimedSysName[i] == system.name)
        {
            if (L) log("updateClaimed", "updating array");
            worldScripts.miningMethods.playerClaimedUnitsPerDay[i] = this.unitsPerDay;
            worldScripts.miningMethods.playerClaimedTimeSinceOwned[i] = this.timeSinceOwned;
            worldScripts.miningMethods.playerClaimedTimeSinceVisited[i] = this.timeSinceVisited;
            worldScripts.miningMethods.playerClaimedProducing[i] = this.producing;
           // worldScripts.miningMethods.playerClaimedDaysOfProduction[i] = this.daysOfProduction;
            worldScripts.miningMethods.playerClaimedDefence[i] = this.defence;
            worldScripts.miningMethods.playerClaimedNarcotics[i] = this.narcBonus;
            worldScripts.miningMethods.playerClaimedLiquor[i] = this.liqBonus;
            worldScripts.miningMethods.playerClaimedMorality[i] = this.morality;

            missionVariables["miningPlayerClaimedID" + i] = this.timeSinceOwned +"*"+this.timeSinceVisited+"^"
                            +this.producing+"£"+this.morality+"$"+this.unitsPerDay+"{"+ this.defence + "}"
                            + this.narcBonus+"#"+this.liqBonus+ this.minePos + system.name + " " + this.baseName + this.mineStatus;
            break;
        }
    }
    if (L) log("updateClaimed", "finshed");

}

this.asteroidMine.prototype.placeKnownAsteroid = function(role) {
    
    this.mineEntity = system.addShips(role, 1, this.minePos, 1);
    if (L) log("miningMethods", "In placeKnownAsteroid: role = " + role + " this.mineEntity = " + this.mineEntity);
}

this.asteroidMine.prototype.placeUnknownAsteroid = function (role)//could have overloaded the above method, but it isn't a lot of difference and this is explicit
{
    this.mineEntity = system.addShips(role, 1, system.sun.position, 1000000);
    this.minePos = Vector3D(this.mineEntity[0].position);
    this.lightSpeedDelay = parseFloat(player.ship.position.distanceTo(this.minePos) / 18600);
    if (L) log("miningMethods", "In placeUnknownAsteroid: role = " + role + " this.mineEntity = " + this.mineEntity[0]);
}
this.asteroidMine.prototype.changeType = function (displayName)
{
    
    this.mineEntity[0].displayName = displayName;
    if (L) log("miningMethods", ">ChangeType: displayName = " + displayName + " this.mineEntity = " + this.mineEntity + " this.mineEntity[0].displayName = " + this.mineEntity[0].displayName);
}
this.asteroidMine.prototype.get = function ()
{
    return this.mineEntity[0];
}

this.asteroidMine.prototype.illicitExtras = function(goods) {
    let mnfst = player.ship.manifest;

    if ( goods === "narcs" ) {
        if ( checkManifest("narcotics") ) {
            player.commsMessage("Narcotics received, this should get them working. Come back later.");
            mnfst.narcotics -= 5;
            this.timeSinceVisited = clock.days;
            this.narcBonus = true;
            this.unitsPerDay += 3;
        }
        else {
            player.commsMessage("You lack the required narcotics. Just say NO, kids.");
            this.timeSinceVisited = clock.days;
        }
    }
    else if ( goods === "firearms" ) {
        if ( checkManifest("firearms") ) {
            player.commsMessage("Weapons received. This mine will be defended.");
            this.timeSinceVisited = clock.days;
            mnfst.firearms -= 5;
            this.defence = true;
            //do something clever
        }
        else {
            player.commsMessage("You don't have enough firearms.");
            this.timeSinceVisited = clock.days;
        }
    }
    else if ( goods === "liqs" ) {
        if ( checkManifest("liquorWines") ) {
            player.commsMessage("Liquor & Wine received. Drunk slaves are better slaves.");
            mnfst.liquorWines -= 5;
            this.timeSinceVisited = clock.days;
            this.liqBonus = true;
            this.unitsPerDay += 3;
        }
        else {
            player.commsMessage("You don't have enough liquor.");
            this.timeSinceVisited = clock.days;
        }
    }
    //if(narcs||firearms||liqs)
        //this.updateClaimed();
    mission.runScreen(worldScripts.miningMethods.illicitChoice, worldScripts.miningMethods.illCall, this); //For a definition of recursion: see "recursion" etc
    
}

this.viewMineMenu = function(thisRef)
{
    if (L) log(this.name, ">viewMineMenu");

    if(worldScripts.miningMethods.playerClaimedName.length == 0)
    {
        player.commsMessage = ("No Mines Commander");
        mission.runScreen(worldScripts.miningMethods.illicitChoice, worldScripts.miningMethods.illCall, thisRef); //For a definition of recursion: see "recursion" etc
    }
    else
    {
        
       worldScripts.miningMethods.mineMenu.title = "\t\tOWNED MINES";
        worldScripts.miningMethods.mineMenu.message = "\n\n\t\tLogged on\n\n\t\tChecking identity...\n\n\nOwner confirmed, welcome back commander\n\nPlease press next to view your first mine";
        worldScripts.miningMethods.mineMenu.choicesKey = "mine_net";
        mineNet.static = 0;
        mission.runScreen(worldScripts.miningMethods.mineMenu, worldScripts.miningMethods.mineNet, thisRef);
    
        
    }
   
    //mineMenuFunc = function(){/*doesn't do anything*/}
    
    
    
}
this.mineNet = function(choice)
{
    
    if(choice === "2_OK")
    {
        mission.runScreen(worldScripts.miningMethods.illicitChoice, worldScripts.miningMethods.illCall, this); //For a definition of recursion: see "recursion" etc
        if (L) log("miningMethods.mineNet", "Done selected. static = " + worldScripts.miningMethods.mineNet.static);
    }
    else if( choice === "1_NEXT")
    {
        if(worldScripts.miningMethods.mineNet.static < worldScripts.miningMethods.playerClaimedName.length )
        {
            var daysOfProduction = clock.days - worldScripts.miningMethods.playerClaimedTimeSinceVisited[worldScripts.miningMethods.mineNet.static];
            if (L) log("miningMethods.mineNet", "Next selected. static = " + worldScripts.miningMethods.mineNet.static);
            worldScripts.miningMethods.mineMenu.title = "OWNED MINES";
            if(worldScripts.miningMethods.playerClaimedName.length == 1)
                worldScripts.miningMethods.mineMenu.message = "\nRecords show you own a claim to only one mine.";
            else if (worldScripts.miningMethods.playerClaimedName.length > 1)
            {
                var number = worldScripts.miningMethods.mineNet.static + 1;
                worldScripts.miningMethods.mineMenu.message = "\nRecords show you own claims to " + worldScripts.miningMethods.playerClaimedName.length + " mines.";
                worldScripts.miningMethods.mineMenu.message += "\nOwned mine number\t" +number;
            }
            worldScripts.miningMethods.mineMenu.message +="\n\n"+worldScripts.miningMethods.playerClaimedName[worldScripts.miningMethods.mineNet.static] + " @ "
                                                                            + worldScripts.miningMethods.playerClaimedSysName[worldScripts.miningMethods.mineNet.static];
                                                                            
            worldScripts.miningMethods.mineMenu.message += "\n\nPosition: " + worldScripts.miningMethods.playerClaimedPositions[worldScripts.miningMethods.mineNet.static];
            
            worldScripts.miningMethods.mineMenu.message += "\n\nMine owned since: " +  worldScripts.miningMethods.playerClaimedTimeSinceOwned[worldScripts.miningMethods.mineNet.static];
                                                                                
            worldScripts.miningMethods.mineMenu.message += "\n\nLast visit: " + worldScripts.miningMethods.playerClaimedTimeSinceVisited[worldScripts.miningMethods.mineNet.static];
            if( worldScripts.miningMethods.playerClaimedProducing[worldScripts.miningMethods.mineNet.static])
            {
                worldScripts.miningMethods.mineMenu.message += "\nHas been producing for " + daysOfProduction + " days.";
                worldScripts.miningMethods.mineMenu.message += "\nCurrently producing " + worldScripts.miningMethods.playerClaimedUnitsPerDay[worldScripts.miningMethods.mineNet.static] + " per day.";
            }
            else
                worldScripts.miningMethods.mineMenu.message += "\nThis mine requires restocking.";

            if(worldScripts.miningMethods.playerClaimedDefence[worldScripts.miningMethods.mineNet.static])
                worldScripts.miningMethods.mineMenu.message += "\nThis mine is defended.";
            else
                worldScripts.miningMethods.mineMenu.message += "\nWarning! This mine is undefended. Without firearms the chances of loss are increased.";
            worldScripts.miningMethods.mineMenu.message += "\n\n\n\t\t\tRight On, Commander!";

            worldScripts.miningMethods.mineNet.static++;
            if(worldScripts.miningMethods.mineNet.static == worldScripts.miningMethods.playerClaimedName.length)
                worldScripts.miningMethods.mineNet.static = 0;
            mission.runScreen(worldScripts.miningMethods.mineMenu, worldScripts.miningMethods.mineNet, this);
            
        }
        else
        {
            if (L) log("miningMethods.mineNet", "Next selected looping back. static = " + worldScripts.miningMethods.mineNet.static);
            worldScripts.miningMethods.mineNet.static = 0;
            mission.runScreen(worldScripts.miningMethods.mineMenu, worldScripts.miningMethods.mineNet, this);
        }   
    }
    //mission.runScreen(worldScripts.miningMethods.illicitChoice, worldScripts.miningMethods.illCall, this); //For a definition of recursion: see "recursion" etc
}
this.illCall = function(choice) {
    let mineObj = worldScripts.miningMethods.getObject(player.ship.position);

    if ( mineObj.narcBonus || mineObj.liqBonus || mineObj.defence )
        mineObj.updateClaimed();

    if ( choice === "1_NARCS" && ! mineObj.narcBonus ) {
        mineObj.illicitExtras("narcs");
        //mission.runScreen(worldScripts.miningMethods.illicitChoice, worldScripts.miningMethods.illCall, this); //pass the "this" parcel
    }
    else if ( choice === "2_LIQS" && ! mineObj.liqBonus ) {
        mineObj.illicitExtras("liqs");
        //mission.runScreen(worldScripts.miningMethods.illicitChoice, worldScripts.miningMethods.illCall, this); //pass the "this" parcel
    }
    else if ( choice === "3_FIREARMS" && ! mineObj.defence ) {
        mineObj.illicitExtras("firearms");
        //mission.runScreen(worldScripts.miningMethods.illicitChoice, worldScripts.miningMethods.illCall, this); //pass the "this" parcel
    }
    else if ( choice === "4_VIEW" ) {
        if (L) log("miningMethods", "4 chosen in illCall");
        worldScripts.miningMethods.viewMineMenu(mineObj);
    }
    else if ( choice === "5_EXIT" ) {
        mission.runScreen(worldScripts.miningMethods.visitMenu, mineObj.vistingMine, mineObj);
    }
    else {
        player.commsMessage("You've already added that resource, commander. To add more you must wait until it has been consumed.");
        mission.runScreen(worldScripts.miningMethods.illicitChoice, worldScripts.miningMethods.illCall, this); //For a definition of recursion: see "recursion" etc
        //self recursion but should "fall off bottom" or "crash everything all to hell". Fingers crossed.
    }
}

this.getObject = function(position)
{
    
    for(var i = 0;i< worldScripts.miningScript.systemAsteroidObjects.length;i++)
    {
        if(worldScripts.miningScript.systemAsteroidObjects[i].mineEntity[0].position.distanceTo(position) < 500)
            return worldScripts.miningScript.systemAsteroidObjects[i];
    }
    return null;

}
this.returnTag = function(stringTag)
{
    var tmp = stringTag.lastIndexOf("-");//our tag identifier isn't added by code but by the displayName of the entity in shipdatwa.plist
    var tmpStr = stringTag.slice(tmp); //claimed, owned or unclaimed?
    if(L) log(this.name, "returnTag: tmp = "+tmp+"\ttmpStr = "+tmpStr);
    return tmpStr;
}

this.updateBeacon = function(minePosition, message, tag) {
    for ( var i = 0; i < worldScripts.miningScript.systemAsteroidObjects.length; i++ ) {
        var position = Vector3D(worldScripts.miningScript.systemAsteroidObjects[i].minePos)

        if(position.distanceTo(minePosition) < 500) {
            if(L)
                log(worldScripts.miningMethods, "UPDATEBEACON....mine.position = " + minePosition + " message = " + message + " tag = " + tag+"distance = " + worldScripts.miningScript.systemAsteroidObjects[i].distance);
            if(worldScripts.miningMethods.timeAdjust)
                timeAccelerationFactor = 1;
            if(player.ship.equipmentStatus("EQ_ADVANCED_COMPASS") === "EQUIPMENT_OK")
                player.consoleMessage(message, 5);
            else
                player.consoleMessage("Mine transmission interecepted. Distance: "+ worldScripts.miningScript.systemAsteroidObjects[i].distance + " miles. An advanced compass may help.", 5);

            let mine = worldScripts.miningScript.systemAsteroidObjects[i].get();
            mine.beaconCode  = 'M';
            mine.beaconLabel = 'Mine';

            if (false) { // WTF??? debug?
            let temp = worldScripts.miningScript.systemAsteroidObjects[i];
            worldScripts.miningScript.systemAsteroidObjects = worldScripts.miningMethods.removeFromArray(worldScripts.miningScript.systemAsteroidObjects, i);
            temp = null;
            mine.remove();
            worldScripts.miningScript.systemAsteroidObjects.push(new worldScripts.miningMethods.asteroidMine(tag, position, "slaveMineOwned"));
            }
            break;
        }
    }    
}
this.revealBeacon = function(position, astObject) {
    //This has been called from firstact by a timer

    if (L)
        log(worldScripts.miningMethods, "REVEALBEACON....mine.position ="+position);
    let maximum = parseInt(worldScripts.miningScript.systemAsteroidObjects.length /4);//dont give everything away

    //this.ship.secondDelay = parseFloat((this.ship.position.distanceTo(player.ship.position)/18600));// light :/ update positional delay
    var randomChance = Math.floor(Math.random()*50);//shits and giggles
    //a random chance will be generated determining whether a beacon transmission will be intercepted by the player
    //0 = anarachy and 7 = corporate state added to a random number up to 10 gives a maximum value of 17
    if(randomChance < 20)
    {
        if (L) log(worldScripts.miningMethods, "Updating beacon.");
        
        //maximum--;//only allow a maximum of 1/4 the asteroids to be revealed (truncated to integer
        
        //var position = mine.position;
        this.updateBeacon(position, "A beacon transmission has been intercepted, Distance: "+astObject.distance+" miles. Beacon uploaded.", "-CLAIMED");
        
        
        //this.updateBeacon(mine);
    }
    else if( randomChance > 19 && randomChance < 35)
    {
        if (L) log(worldScripts.miningMethods, "adding explosion");
        //more randomness, possibility of a ship exploding outside an unknown station
        var pirate = system.addShips("blackdog", 1, astObject.minePos, 5);
        if(pirate)
            pirate[0].explode();
    }
    else
    {
        if (L) log(worldScripts.miningMethods, "adding space battle");

        var pirate = system.addShips("blackdog", 5, astObject.minePos, 5);
        if(pirate)
        {//space battle, follow the lasers
            pirate[0].target = pirate[1];
            pirate[2].target = pirate[0];
            pirate[3].target = pirate[2];
            pirate[4].target = pirate[3];//4 is the lucky one
        }
    }
}

this.rebuildPerpVariables = function()
{
    
    //arrayOfMines = arrayOfMines.concat(tmpArrayOfMines);
    for(var n = 0; n < worldScripts.miningScript.maxMines; n++)
    {//reset all possible variables, it keeps things tidy
        missionVariables["miningSystemPerp" + n] = ""; // It's only, like, partly perpetual for one system only. Man.
    }
    if(worldScripts.miningScript.systemAsteroidObjects)
    {
        for(var n = 0; n < worldScripts.miningScript.systemAsteroidObjects.length; n++)
        {//not all slaveMineOwned are Owned... its a workaround for no beacon control
            var mineEntity = worldScripts.miningScript.systemAsteroidObjects[n].get();
            missionVariables["miningSystemPerp" + n.toString()] = mineEntity.position + system.name + " " + mineEntity.displayName;
        }
        missionVariables.miningSystemAsteroids = worldScripts.miningScript.systemAsteroidObjects.length;
        if (L) log(this.name, "Rebuilt systemAsteroids array. missionVariables.miningSystemAsteroids = " + missionVariables.miningSystemAsteroids );
    }
    //worldScripts.miningScript.systemAsteroids = [];
    //worldScripts.miningScript.systemAsteroids = this.makeArray(missionVariables.miningSystemAsteroids, "miningSystemPerp");//All that, for this, it will magically leave out any which have been a problem
    
}
this.makeArray = function(numberOfElements, variableString)
{
    //this is meant to take missionVariables and create an array
    
    var array = [];//For someone who was raised on ANSI C and assembler, this is fancy.
    if(numberOfElements > 0)
    {
        for(var i = 0; i < numberOfElements; i++)
        {
            array[i] = missionVariables[variableString + i.toString()];
        }
    }
    if (L) log(this.name, "MAKEARRAY:\tnumberOfElements = " + numberOfElements + "\tvariableString = " + variableString + "\tarray[] = " + array);
    return array;
    
}
this.buildClaimedArrays = function ()
{
    for(var i = 0; i < worldScripts.miningScript.miningClaimedNumber; i++)
    {    
        this.playerClaimedUnitsPerDay[i] = this.getUnitsPerDay(i);
        
        this.playerClaimedTimeSinceOwned[i] = this.getTimeSinceOwned(i);
        
        this.playerClaimedTimeSinceVisited[i] = this.getTimeSinceVisited(i);

        this.playerClaimedProducing[i] = this.getProducing(i);

        this.playerClaimedPositions[i] = this.getPositionVector(this.playerClaimedMines[i]);
        
        this.playerClaimedSysName[i] = this.getSystemName(this.playerClaimedMines[i]);
        
        this.playerClaimedName[i] = this.getDisplayName(this.playerClaimedMines[i]);
        
        this.playerClaimedDefence[i] = this.getDefence(i);
        
        this.playerClaimedNarcotics[i] = this.getNarcotics(i);
        
        this.playerClaimedLiquor[i] = this.getLiquor(i);

        this.playerClaimedMorality[i] = this.getMorality(i);
        
       // this.playerClaimedDaysOfProduction[i] = this.getDaysOfProduction(i);


        if(L)
        {
            log(this.name, "BUILDING ARRAYS\ni = " + i + "\tplayerClaimedMines length = " + (this.playerClaimedMines.length).toString());
            log(this.name, "missionVariables[\"miningPlayerClaimedID\"+ i] = " + missionVariables["miningPlayerClaimedID" + i.toString()]);
            //we want an array of the positions, names and of the system names
            log(this.name, "Pos:");
        }
    }
}
this.getPositionVector = function(variableString)
{
    
    
    //this will pull the position form our variable string.
    //the position is easy to find because it is enclosed with brackets
    //and seperated by commas and spaces
    var tempInt = variableString.indexOf("(");//beginning of vector string
    var tempInt2 = variableString.indexOf(",");//end of x coordinate
    
    if(L)
        log(this.name,"getPositionVector:\tvariableString = " + variableString + "\ttempInt = " + tempInt + "\ntempInt2 = " + tempInt2);
    
    var xStr = variableString.slice(tempInt+1);//cuts off the beginning of the string
    var xCoord = parseFloat(xStr); //take (x) coord
    //parseFloat saves having to cut off the end of the string, it'll parse the float until it reaches a non-number or non-number-symbol (+ and -)
    
    if(L)
        log(this.name,"xCoord = " + xCoord.toString());
    
    var tempInt1 = variableString.lastIndexOf(",");//second comma denotes beginning of third number
    var yStr = variableString.slice(tempInt2+1);//cuts off first coordinate, leaving second and third
    var yCoord = parseFloat(yStr);//gives second (y) coord
    if(L)
        log(this.name,"yCoord = " + yCoord.toString());
    
    var zStr = variableString.slice(tempInt1+1);//leaves us with third coordinate and junk at end of string
    var zCoord = parseFloat(zStr);//take the third (z) coord
    
    if(L)
    {
        log(this.name,"zCoord = " + zCoord.toString());
        log(this.name, variableString + " " + xCoord+ " n=s "+xStr+" "+ yCoord +" n=s "  +yStr+ " n=s " +zCoord+" n=s "+zStr);
    }    
    var position = Vector3D(xCoord,yCoord,zCoord);//turn those three numbers into a doohicky
    return position;
}
this.getSystemName = function(stringSysName)
{    
    var intTemp = stringSysName.indexOf(")");//end of position coordinates
    var intTemp2 = stringSysName.lastIndexOf(" ");//the space after the system name
    
    if(L)
        log(this.name, "stringSysName = " + stringSysName + "intTemp = " + intTemp + "intTemp2 = " + intTemp2);
    
    return stringSysName.slice(intTemp+1, intTemp2); // system.name
}
this.getDisplayName = function(stringDisplayName)
{    
    var intTemp = stringDisplayName.lastIndexOf(" ");//the space after the system name
    var strTemp = stringDisplayName.slice(intTemp+1);//display name
    
    if(L)
        log(this.name, "DISPLAYNAME:   stringDisplayName = "+ stringDisplayName + "\tintTemp = " + intTemp + "\tstrTemp = " + strTemp);
    
    return strTemp;
}
this.removeFromArray = function (array, position)
{
    //removeone element and close the gap and returns new array
    //WARNING: this will not adjust any counters associated with the array
    var temp1 =[];
    var temp2 = [];
    
    if(position != 0)
    {
        temp1 = array.slice(0, position); //get everything before the position parameter
        temp2 = array.slice(position+1)//and everything after, excluding the element at position

        array = temp1.concat(temp2);//concatanate.. another one of those terms only programmers use
        return array;
    }
    else
    {
        array = array.slice(1);
        return array;
    }
}

//String slicing methods for populating arrays
this.getUnitsPerDay = function(i)
{
    var tempInt2 = missionVariables["miningPlayerClaimedID" + i].indexOf("$");
    //var tempInt = missionVariables["miningPlayerClaimedID" + i].indexOf("{");
    var unitsDay = parseInt(missionVariables["miningPlayerClaimedID" + i].slice(tempInt2+1),10);
    return unitsDay;
}
this.getTimeSinceOwned = function(i)
{
    var tempInt = missionVariables["miningPlayerClaimedID" + i].indexOf("*");
    var timeOwned = parseInt(missionVariables["miningPlayerClaimedID" + i].slice(0,tempInt),10);
    return timeOwned;
}
this.getTimeSinceVisited = function (i)
{
    var tempInt = missionVariables["miningPlayerClaimedID" + i].indexOf("*");
    //var tempInt2 = missionVariables["miningPlayerClaimedID" + i].indexOf("^");
    var timeVisited = parseInt(missionVariables["miningPlayerClaimedID" + i].slice(tempInt+1),10);
    return timeVisited;
}
this.getProducing = function(i)
{
    var tempInt = missionVariables["miningPlayerClaimedID" + i].indexOf("£");
    var tempInt2 = missionVariables["miningPlayerClaimedID" + i].indexOf("^");
    var producing = false;
    if(missionVariables["miningPlayerClaimedID" + i].slice(tempInt2+1, tempInt) == "true")
        producing = true;
    return producing;
}
this.getMorality = function(i)
{

    var tempInt = missionVariables["miningPlayerClaimedID" + i].indexOf("£");
    var tempInt2 = missionVariables["miningPlayerClaimedID" + i].indexOf("$");
    var morality = missionVariables["miningPlayerClaimedID" + i].slice(tempInt+1, tempInt2);
    return morality;//LOL
}
this.getDefence = function(i)
{
    var tempInt = missionVariables["miningPlayerClaimedID" + i].indexOf("{");
    var tempInt2 = missionVariables["miningPlayerClaimedID" + i].indexOf("}");
    var defence =false;
    if(missionVariables["miningPlayerClaimedID" + i].slice(tempInt+1, tempInt2) == "true")
        defence = true;
    return defence;
}
this.getNarcotics = function(i) //this is not advice
{
    var tempInt = missionVariables["miningPlayerClaimedID" + i].indexOf("}");
    var tempInt2 = missionVariables["miningPlayerClaimedID" + i].indexOf("#");
    var narcs = false;
    if(missionVariables["miningPlayerClaimedID" + i].slice(tempInt+1, tempInt2) == "true")
        narcs = true;
    return narcs;
}
this.getLiquor = function(i) //and this is
{
    var tempInt = missionVariables["miningPlayerClaimedID" + i].indexOf("#");
    var tempInt2 = missionVariables["miningPlayerClaimedID" + i].indexOf("(");
    var liqs = false;
    if(missionVariables["miningPlayerClaimedID" + i].slice(tempInt+1, tempInt2) == "true")
        liqs = true;
    return liqs;
}
this.removeClaimedString = function ()
{
    //blank and refill from array, because we dont have a push() method for missionVariables
    //This will simply rebuild from the array and set the last value to "", blatant but effective
    for(var i = 0; i < worldScripts.miningMethods.playerClaimedMines.length; i ++)
    {
        missionVariables["miningPlayerClaimedID" + i] = this.playerClaimedMines[i];
    }
    if(worldScripts.miningMethods.playerClaimedMines.length > 0)
        missionVariables["miningPlayerClaimedID" + worldScripts.miningMethods.playerClaimedMines.length - 1] = ""; //set last one to ""
}

this.checkManifest = function(resource) {
    let mnfst = player.ship.manifest;
    switch (resource) {
        case "slaves":
            if (mnfst.slaves >= 5) return true;
        case "food":
            if (mnfst.food >= 20) return true;
        case "liquorWines":
            if (mnfst.liquorWines >= 5) return true;
        case "narcotics":
            if (mnfst.narcotics >= 5) return true;
        case "firearms":
            if (mnfst.firearms >= 5) return true;
        case "computers":
            if (mnfst.computers >= 5) return true;
        case "machinery":
            if (mnfst.machinery >= 20) return true;
    }
    return false;
}

this.removeOwned = function(i)
{
    if (L) log(this.name, "REMOVE OWNED: i = " + i);
    if(missionVariables["miningPlayerClaimedNumber"] > 0)
    {
        //this is the one
        //i = worldScripts.miningMethods.playerClaimedMines.length;
        worldScripts.miningMethods.playerClaimedMines = worldScripts.miningMethods.removeFromArray(worldScripts.miningMethods.playerClaimedMines, i);//hiddeous JS
        worldScripts.miningMethods.playerClaimedPositions = worldScripts.miningMethods.removeFromArray(worldScripts.miningMethods.playerClaimedPositions, i);
        worldScripts.miningMethods.playerClaimedSysName = worldScripts.miningMethods.removeFromArray(worldScripts.miningMethods.playerClaimedSysName, i);
        worldScripts.miningMethods.playerClaimedName = worldScripts.miningMethods.removeFromArray(worldScripts.miningMethods.playerClaimedName, i);
        worldScripts.miningMethods.playerClaimedUnitsPerDay = worldScripts.miningMethods.removeFromArray(worldScripts.miningMethods.playerClaimedUnitsPerDay, i);
        worldScripts.miningMethods.playerClaimedTimeSinceOwned = worldScripts.miningMethods.removeFromArray(worldScripts.miningMethods.playerClaimedTimeSinceOwned, i);
        worldScripts.miningMethods.playerClaimedTimeSinceVisited = worldScripts.miningMethods.removeFromArray(worldScripts.miningMethods.playerClaimedTimeSinceVisited, i);
        worldScripts.miningMethods.playerClaimedProducing = worldScripts.miningMethods.removeFromArray(worldScripts.miningMethods.playerClaimedProducing, i);
        //worldScripts.miningMethods.playerClaimedDaysOfProduction = worldScripts.miningMethods.removeFromArray(worldScripts.miningMethods.playerClaimedDaysOfProduction, i);
        //need to rebuild missionVariables miningPlayerClaimedNumber
        worldScripts.miningMethods.playerClaimedDefence = worldScripts.miningMethods.removeFromArray(worldScripts.miningMethods.playerClaimedDefence, i);
        worldScripts.miningMethods.playerClaimedNarcotics = worldScripts.miningMethods.removeFromArray(worldScripts.miningMethods.playerClaimedNarcotics, i);
        worldScripts.miningMethods.playerClaimedLiquor = worldScripts.miningMethods.removeFromArray(worldScripts.miningMethods.playerClaimedLiquor, i);
        
        missionVariables["miningPlayerClaimedNumber"]--;
        
    }
    else
    {
        worldScripts.miningMethods.playerClaimedMines = [];
        worldScripts.miningScript.playerClaimedPositions = [];
        worldScripts.miningScript.playerClaimedSysName = [];
        worldScripts.miningScript.playerClaimedName = [];
        worldScripts.miningMethods.playerClaimedUnitsPerDay = [];//How many units the mine is producing
        worldScripts.miningMethods.playerClaimedTimeSinceOwned = [];//the day the player took over
        worldScripts.miningMethods.playerClaimedTimeSinceVisited = [];//time since restocking
        worldScripts.miningMethods.playerClaimedProducing = [];//A boolean value
      //  worldScripts.miningMethods.playerClaimedDaysOfProduction = [];//How many days has this mine been producing product
        worldScripts.miningMethods.playerClaimedDefence = [];
        worldScripts.miningMethods.playerClaimedNarcotics = [];
        worldScripts.miningMethods.playerClaimedLiquor = [];
        //worldScripts.miningScript.removeClaimedString();
        missionVariables["miningPlayerClaimedNumber"] = 0;
        
    }
    worldScripts.miningMethods.removeClaimedString();
}

this.removeOwnedOverload = function(position) //overload of above function... sneaky JS pretends to support proper overloading but instead uses last declared function
{
    var i = null;
    for(i = 0; i < worldScripts.miningMethods.playerClaimedMines.length; i ++)
    {
        if(position.distanceTo(worldScripts.miningMethods.playerClaimedPositions[i]) < 1000 && worldScripts.miningMethods.playerClaimedSysName[i] == system.name)
            break;
        if(i == worldScripts.miningMethods.playerClaimedMines.length -1)//getting here means we can't find it
        {
            i = null;
            break;
        }
    }
    if (L) log(this.name, "REMOVE OWNED: i = " + i);
    if(missionVariables["miningPlayerClaimedNumber"] > 0 && i)
    {
        //this is the one
        //i = worldScripts.miningMethods.playerClaimedMines.length;
        worldScripts.miningMethods.playerClaimedMines = worldScripts.miningMethods.removeFromArray(worldScripts.miningMethods.playerClaimedMines, i);//hiddeous JS
        worldScripts.miningMethods.playerClaimedPositions = worldScripts.miningMethods.removeFromArray(worldScripts.miningMethods.playerClaimedPositions, i);
        worldScripts.miningMethods.playerClaimedSysName = worldScripts.miningMethods.removeFromArray(worldScripts.miningMethods.playerClaimedSysName, i);
        worldScripts.miningMethods.playerClaimedName = worldScripts.miningMethods.removeFromArray(worldScripts.miningMethods.playerClaimedName, i);
        worldScripts.miningMethods.playerClaimedUnitsPerDay = worldScripts.miningMethods.removeFromArray(worldScripts.miningMethods.playerClaimedUnitsPerDay, i);
        worldScripts.miningMethods.playerClaimedTimeSinceOwned = worldScripts.miningMethods.removeFromArray(worldScripts.miningMethods.playerClaimedTimeSinceOwned, i);
        worldScripts.miningMethods.playerClaimedTimeSinceVisited = worldScripts.miningMethods.removeFromArray(worldScripts.miningMethods.playerClaimedTimeSinceVisited, i);
        worldScripts.miningMethods.playerClaimedProducing = worldScripts.miningMethods.removeFromArray(worldScripts.miningMethods.playerClaimedProducing, i);
        //worldScripts.miningMethods.playerClaimedDaysOfProduction = worldScripts.miningMethods.removeFromArray(worldScripts.miningMethods.playerClaimedDaysOfProduction, i);
        //need to rebuild missionVariables miningPlayerClaimedNumber
        worldScripts.miningMethods.playerClaimedDefence = worldScripts.miningMethods.removeFromArray(worldScripts.miningMethods.playerClaimedDefence, i);
        worldScripts.miningMethods.playerClaimedNarcotics = worldScripts.miningMethods.removeFromArray(worldScripts.miningMethods.playerClaimedNarcotics, i);
        worldScripts.miningMethods.playerClaimedLiquor = worldScripts.miningMethods.removeFromArray(worldScripts.miningMethods.playerClaimedLiquor, i);
        
        missionVariables["miningPlayerClaimedNumber"]--;
        
    }
    else if (missionVariables["miningPlayerClaimedNumber"] < 1)
    {
        worldScripts.miningMethods.playerClaimedMines = [];
        worldScripts.miningScript.playerClaimedPositions = [];
        worldScripts.miningScript.playerClaimedSysName = [];
        worldScripts.miningScript.playerClaimedName = [];
        worldScripts.miningMethods.playerClaimedUnitsPerDay = [];//How many units the mine is producing
        worldScripts.miningMethods.playerClaimedTimeSinceOwned = [];//the day the player took over
        worldScripts.miningMethods.playerClaimedTimeSinceVisited = [];//time since restocking
        worldScripts.miningMethods.playerClaimedProducing = [];//A boolean value
        //  worldScripts.miningMethods.playerClaimedDaysOfProduction = [];//How many days has this mine been producing product
        worldScripts.miningMethods.playerClaimedDefence = [];
        worldScripts.miningMethods.playerClaimedNarcotics = [];
        worldScripts.miningMethods.playerClaimedLiquor = [];
        //worldScripts.miningScript.removeClaimedString();
        missionVariables["miningPlayerClaimedNumber"] = 0;
        
    }
    worldScripts.miningMethods.removeClaimedString();
}

}).call(this);
